/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3) 
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details. 
 */

package org.dive4elements.river.artifacts.model;

import org.dive4elements.artifactdatabase.state.Facet;
import org.dive4elements.artifacts.Artifact;
import org.dive4elements.artifacts.CallContext;
import org.dive4elements.river.artifacts.FLYSArtifact;
import org.dive4elements.river.artifacts.states.DefaultState.ComputeType;


/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class HistoricalDischargeCurveFacet extends DataFacet {

    public HistoricalDischargeCurveFacet() {
    }

    public HistoricalDischargeCurveFacet(int index, String name,
        String description, ComputeType type, String stateID, String hash

    ) {
        super(index, name, description, type, hash, stateID);
    }

    @Override
    public Facet deepCopy() {
        WaterlevelFacet copy = new WaterlevelFacet();
        copy.set(this);
        copy.type = type;
        copy.hash = hash;
        copy.stateId = stateId;
        return copy;
    }

    @Override
    public Object getData(Artifact artifact, CallContext context) {
        FLYSArtifact flys = (FLYSArtifact) artifact;

        CalculationResult res = (CalculationResult) flys.compute(context, hash,
            stateId, type, false);

        HistoricalDischargeData data = (HistoricalDischargeData) res.getData();
        WQKms[] wqkms = (WQKms[]) data.getWQs();

        return wqkms[index];
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
